#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdlib.h>
#include "servicio.h"

static unsigned int mcd (unsigned int a, unsigned int b) {
	unsigned int res=0;
	if ((a>0) && (b>0)) {
		res = (a<b ? a : b);
		while (1) {
			if ((a%res == 0) && (b%res == 0)) break;
			else res--;
		}
	}
	return res;
}
static unsigned int mcm (unsigned int a, unsigned int b) {
	unsigned int res=0;
	if ((a>0) && (b>0)) {
		res = (a>b ? a : b);
		while (1) {
			if ((res%a == 0) && (res%b == 0)) break;
			else res++;
		}
	}
	return res;
}

int main(int argc, char **argv) {
        int s, s_conec;
	unsigned int res;
        unsigned int tam_dir;
        struct sockaddr_in dir, dir_cliente;
	struct mensaje m;

        if ((s=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
                perror("error creando socket");
                return 1;
        }
        dir.sin_addr.s_addr=INADDR_ANY;
        dir.sin_port=htons(56789);
        dir.sin_family=PF_INET;
        if (bind(s, (struct sockaddr *)&dir, sizeof(dir)) < 0) {
                perror("error en bind");
                close(s);
                return 1;
        }
        if (listen(s, 5) < 0) {
                perror("error en listen");
                close(s);
                return 1;
        }
        while (1) {
                tam_dir=sizeof(dir_cliente);
                if ((s_conec=accept(s, (struct sockaddr *)&dir_cliente, &tam_dir))<0){
                        perror("error en accept");
                        close(s);
                        return 1;
                }
		if (read(s_conec, &m, sizeof(m))!=sizeof(m)) {
			perror("error en read"); close(s); return 1;
		}
		if (ntohl(m.op) == MCM)
			res = htonl(mcm(ntohl(m.a), ntohl(m.b)));
		else if (ntohl(m.op) == MCD)
			res = htonl(mcd(ntohl(m.a), ntohl(m.b)));
		else {
			fprintf(stderr, "Operación no implementada\n");
			res = htonl(0);
		}
		if (write(s_conec, &res, sizeof(res))!=sizeof(unsigned int)){
                        perror("error en write"); close(s); return 1;
                }
		close(s_conec);
        }
	return 0;
}
